#include "Header.h"
#include "Log.h"
#include "fase.h"

bool encerra=false;

int mapvet[] = {0,1,2,3,4};
int mapsize=5;
int estadoatual=1;
int fase = 1;
int vel_coracao = 0;
int pause_saida = 0;
int sai_fase=0;
int som_cnt=0;
double count_personagem=0;

unsigned int fonte32=0;
unsigned int fonte64=0;
unsigned int botao_jogar=0;
unsigned int botao_ajuda = 0;
unsigned int botao_creditos=0;
unsigned int botao_menu = 0;
unsigned int botao_voltar=0;
unsigned int botao_sair=0;
unsigned int botao_proximo = 0;
unsigned int spmira=0;
unsigned int titulo=0;
unsigned int pause = 0;
unsigned int score = 0;
unsigned int win = 0;

char text_vel[5];

unsigned int musicas[musics];//musicas do jogo...
unsigned int sons[musics];//efeitos sonoros do jogo...
unsigned int objetos_sprites[objetos_sprite];

bool player_possui_chave=false;//armazena informao se player pegou a chave

int objeto_e_chave;//marca qual objeto  uma chave
int objetos[objetos_sprite];//Possui trs objetos ou menos, cada objeto ir armazenar um nmero que ir fazer referncia a qual objeto est na tela
int objetos_posx[objetos_sprite];//Posio horizontal dos objetos
int objetos_posy[objetos_sprite];//Posio vertical dos objetos
int objetos_tamanho_x[objetos_sprite];//define o tamanho horizontal do objeto
int objetos_tamanho_y[objetos_sprite];//define o tamanho vertical do objeto

int jogador_animacao;//Salva a sprite que o jogador est
int jogador_move_direita_inicio=1;//armazena onde inicia as sprites do player andando
int jogador_move_direita_fim=8;//armazena onde termina as sprites do player andando
int jogador_move_esquerda_inicio=10;//armazena onde inicia as sprites do player andando
int jogador_move_esquerda_fim=16;//armazena onde termina as sprites do player andando
int jogador_sprite_pula=1;//armazena a posio do vetor de onde est a sprite de pular
int jogador_sprite_abaixa=5;//armazena a posio do vetor onde est a sprite de abaixar
int jogador_sprite_parado=0;//armazena a posio do vetor onde est a sprite de ficar parado
int jogador_sprite_dormindo=11;//...

Componente *personagens = AlocaVetorPersonagens(qtd_personagem+1);
Componente *mapa = AlocaVetorMapa(15);
Componente *fundo = AlocaVetorMapaCarregado(qtd_fundo);
Componente *Monstros = AlocaVetorPersonagens(qtd_monstros+1);
Componente *Objetos = AlocaVetorPersonagens(qtd_objetos+1);
unsigned int Sprites_Fundo[6];
Componente mapa_fundo[200];

extern bool randomiza_coisas=true;
unsigned int jogador;
unsigned int jogador2;
unsigned int textura_gato[12];
int textura_fundo=0;
int chave_setor;
int porta_chave;
int porta_setor;
int jogador_setor;
ArquivoLog *Log = AlocaLog();

 int main(int narg, char **valarg)
{
	inicia_randomizador();
	xcon_create();
	srand(time_t(0));
	if(C2D2_Inicia(1280, 1000, C2D2_JANELA, C2D2_DESENHO_PADRAO, "Beyond the Edge"))
		printf("Chiend2D2 initialized.\n");
	else
	{
		printf("Failed to initialized Chien2D2. Closing.\n");
		return 0;
	}
	C2D2P_Inicia();
	if(CA2_Inicia()){
		printf("Audio initialized.\n");
	}
	else
		printf("Failed to initialized the audio.\n");
	personagens[0].selecionado = true;
	personagens[0].menina = true;
    if(CarregaRecursos())
    {
        do
	    {
			switch(estadoatual)
            {
                case 1:
                    TelaPrincipal();
                    break;
                case 2:
                    TelaJogo();
                    break;
                case 3:
                    TelaCreditos();
                    break;
				case 4:
					TelaPause();
					break;
				case 5:
					Fase();
					randomiza_coisas=true;
					zera_objetos();
					sai_fase = 0; // FORA A ZERAR
					break;
				case 8:
					TelaAjuda();
					break;
				case 10:
					Win();
					break;
                default:
                    encerra=true;
                    break;
            }
			CA2_FadeMusica(0);
	    }
	    while(!encerra);
    }
    DescarregaRecursos();
	CA2_Encerra();
	C2D2_Encerra();
	xcon_destroy();
	return 0;
}