#include "Header.h"


//Seleciona objetos Randomicos na tela
extern int objeto_e_chave;//marca qual objeto  uma chave
extern int objetos[6];//Possui trs objetos ou menos, cada objeto ir armazenar um nmero que ir fazer referncia a qual objeto est na tela
extern int objetos_posx[6];//Posio horizontal dos objetos
extern int objetos_posy[6];//Posio vertical dos objetos
extern int objetos_tamanho_x[6];//tamanho horizontal do objeto
extern int objetos_tamanho_y[6];//o tamanho vertical do objeto
extern unsigned int objetos_sprites[6];

bool evita_sobreposicao(int pos_atual);
void testa_tamanho_objetos(int obj, int posx,int posy);

//tenque testar se funciona
int seleciona_objeto_randomico(){//Retornaria qual objeto iria estar na tela e seleciona quais objetos sero eles
	int i=0;
	int sorteia_objeto=0;
	int qnt_objetos;
	qnt_objetos=randomiza(3,5);
	printf("inicia selecionador de objetos\n");
	while(i<qnt_objetos){
		do{
			sorteia_objeto=randomiza(1,5);
			printf("adicionando elemento %d, elemento:",i);
			objetos[i]=sorteia_objeto;
			switch(sorteia_objeto){
				case pedra:
					printf("pedra\n");
					objetos_posx[i]=randomiza(0,750);
					objetos_tamanho_x[i]=37;//tamanho suposto da horizontal da pedra
					objetos_tamanho_y[i]=26;//tamanho suposto da vertical da pedra
					objetos_posy[i]=374;
					break;
				case gato:
					printf("gato\n");
					objetos_tamanho_x[i]=53;//tamanho suposto da horizontal da gato
					objetos_tamanho_y[i]=21;//tamanho suposto da vertical da gato
					objetos_posx[i]=747;
					objetos_posy[i]=randomiza(100,400)-objetos_tamanho_y[i];
					break;
				case chave:
					printf("chave\n");
					objetos_tamanho_x[i]=48;//tamanho suposto da horizontal da telefone
					objetos_tamanho_y[i]=16;//tamanho suposto da vertical da telefone
					objetos_posx[i]=randomiza(0,750);
					objetos_posy[i]=384;
					break;
				case porta:
					printf("porta\n");
					objetos_tamanho_x[i]=48;//tamanho suposto da horizontal da porta
					objetos_tamanho_y[i]=96;//tamanho suposto da vertical da porta
					objetos_posx[i]=randomiza(0,750);
					objetos_posy[i]=304;
					break;
				case moeda:
					printf("moeda\n");
					objetos_tamanho_x[i]=19;//tamanho suposto da horizontal da moeda
					objetos_tamanho_y[i]=15;//tamanho suposto da vertical da moeda
					objetos_posx[i]=randomiza(0,750);
					objetos_posy[i]=385;
					break;
			}
		}while(evita_sobreposicao(i));
		testa_tamanho_objetos(objetos[i],objetos_posx[i],objetos_posy[i]);
		i++;
	}
	for(i=0;i<maximo_objetos;i++){
		printf("testa integridade %d:",i);
		testa_tamanho_objetos(objetos[i],objetos_posx[i],objetos_posy[i]);
		printf("\n");
	}
	return qnt_objetos;
}

bool chave_ja_sorteada=true;
int setor_chave=0;
int setor=0;

bool evita_sobreposicao(int pos_atual){
	int i=0;
	bool colide=false;
	while(i<pos_atual && colide==false){
		if(C2D2_ColidiuSprites(objetos_sprites[objetos[i]],0,objetos_posx[i],objetos_posy[i],objetos_sprites[objetos[pos_atual]],0,objetos_posx[pos_atual],objetos_posy[pos_atual])){
			colide=true;
		}
		i++;
	}
	return colide;
}

void zera_objetos(){
	int i=0;
	while(i<maximo_objetos){
		objetos[i]=0;
		objetos_posx[i]=0;
		objetos_posy[i]=0;
		objetos_tamanho_x[i]=0;
		objetos_tamanho_y[i]=0;
		i++;
	}
}

void testa_tamanho_objetos(int obj, int posx,int posy){
	if(obj){
		switch(obj){
		case pedra:
			if(posy+26!=400){
				printf("tamanho incorreto\n");
			}
			break;
		case gato:
			if(posx+53!=800){
				printf("tamanho incorreto\n");
			}
			break;
		case chave:
			if(posy+16!=400){
				printf("tamanho incorreto\n");
			}
			break;
		case porta:
			if(posy+96!=400){
				printf("tamanho incorreto\n");
			}
			break;
		case moeda:
			if(posy+15!=400){
				printf("tamanho incorreto\n");
			}
			break;
		}
	}
}
