#include "Header.h"

#define canto_esquerdo 2
#define canto_direito  1
#define altura_chao 820
#define imagem_fundo 3
#define	qtd_personagem  2
#define qtd_fundo 5
#define	musics 2
#define	objetos_sprite 6

#define pula 1
#define cai  2
#define parado 0
int jogador_pula[2];
void gravidade_jogador(int jogador);

extern Componente *fundo;
extern Componente *mapa;
extern Componente *personagens;
extern unsigned int sprite_jogador[6];//Vetor onde sero salvos as sprites do player
extern int jogador_animacao;//Salva a animacao que o jogador est
extern int jogador_sprite_pula;//armazena a posio do vetor de onde est a sprite de pular
extern int jogador_sprite_abaixa;//armazena a posio do vetor onde est a sprite de abaixar
extern int jogador_sprite_parado;//armazena a posio do vetor onde est a sprite de ficar parado
extern int jogador_sprite_dormindo;//...
extern int jogador_move_direita_inicio;//armazena onde inicia as sprites do player andando
extern int jogador_move_direita_fim;//armazena onde termina as sprites do player andando
extern int jogador_move_esquerda_inicio;//armazena onde inicia as sprites do player andando
extern int jogador_move_esquerda_fim;//armazena onde termina as sprites do player andando
extern double count_personagem;

int animacao_atual=0;
int pos_anim_atual=0;
int cnt_mov=0;

Componente *AlocaVetorPersonagens(int qtd){
	Componente *p = (Componente*) malloc (qtd * sizeof(Componente));
	for(int I = 0; I<qtd; I++){
		p[I].aceleracaoX = 0;
		p[I].aceleracaoY = 0;
		p[I].animacao = 0;
		p[I].loadSprite = 0;
		p[I].tamanhoX = 573;
		p[I].tamanhoY = 672;
		p[I].posX = (52*(I + 1));
		p[I].posY = altura_chao- p[I].tamanhoY;
		p[I].selecionado = false;
		p[I].menina = false;
		p[I].pingente = (bool*) malloc (3 * sizeof(bool));
		for(int J = 0; J<4; J++){
			p[I].pingente[J] = false;
		}
	}
	return p;
}

Componente *AlocaVetorMapa(int qtd){
	Componente *p = (Componente*) malloc (qtd * sizeof(Componente));
	for(int I = 0; I<qtd; I++){
		p[I].aceleracaoX = 0;
		p[I].aceleracaoY = 0;
		p[I].animacao = 0;
		p[I].loadSprite=0;
		if(I == 0){
			p[I].posX = 0;
		}else{
			p[I].posX = p[I-1].posX + 496;
		}
		p[I].posY = 0;
		p[I].tamanhoX = 500;
		p[I].tamanhoY = 1280;
		p[I].selecionado = false;
	}
	return p;
}

Componente *AlocaVetorMapaCarregado(int qtd){
	Componente *p = (Componente*) malloc (qtd * sizeof(Componente));
	for(int ii=qtd-1;ii>=0;ii--){
		p[ii] = mapa[ii];
		p[ii].loadSprite = mapa[ii].loadSprite;
	}
	return p;
}


void trocaPersonagem(){
	C2D2_Botao *teclas = C2D2_PegaTeclas();
	if(teclas[C2D2_ESPACO].pressionado || xcon_is_key_pressed(xcon_key_x)){
		personagens[0].selecionado = !personagens[0].selecionado;
		personagens[1].selecionado = !personagens[1].selecionado;
		Componente aux;
		int aux2;
		aux = personagens[1];
		personagens[1] = personagens[0];
		personagens[0] = aux;
		aux2 = jogador_pula[0];
		jogador_pula[0] = jogador_pula[1];
		jogador_pula[1] = aux2;
//		jogador_pula[1]=cai;
	}
 }

int move_jogador(){
	int situacao=0;	
	C2D2_Botao *teclas = C2D2_PegaTeclas();
	gravidade_jogador(0);
	if(personagens[0].posX+personagens[0].aceleracaoX<=50 || personagens[1].posX+personagens[1].aceleracaoX<=50){//Player colidiu com o fim do canto esquerdo
		situacao=canto_esquerdo;
 		if(detectaColisaofundo(personagens[0],fundo[0]) && fundo[0].posX != mapa[0].posX){
			if(fundo[0].posX != mapa[0].posX){
				carregamapaatras();
				for(int i=0;i<qtd_fundo;i++){
					fundo[i].posX+=personagens[0].aceleracaoX;
				}
			}else{
				//personagens[0].posX+=personagens[0].aceleracaoX;//seta nova posicao do player
				//personagens[0].posY+=personagens[0].aceleracaoY;
				//personagens[1].posX+=personagens[1].aceleracaoX;//seta nova posicao do player
				//personagens[1].posY+=personagens[1].aceleracaoY;
			}
		}
	}
	else if(personagens[0].posX+personagens[0].aceleracaoX>=750-32 || personagens[1].posX+personagens[1].aceleracaoX>=750-32){//Player colidiu com o fim do canto direito
		situacao=canto_direito;
		if(detectaColisaofundo(personagens[0],fundo[qtd_fundo-1])){
			carregamapafrente();
			for(int i=0;i<qtd_fundo;i++){
				fundo[i].posX-=personagens[0].aceleracaoX;
			}
		}else{
							jogador_pula[0]=cai;
				jogador_pula[1]=cai;
				//personagens[0].posX-=personagens[0].aceleracaoX;//seta nova posicao do player
				//personagens[0].posY-=personagens[0].aceleracaoY;
				//personagens[1].posX-=personagens[1].aceleracaoX;//seta nova posicao do player
				//personagens[1].posY-=personagens[1].aceleracaoY;
		}
	}
	else{//movimenta o player
		if(!detectaColisao()){
			personagens[0].posX+=personagens[0].aceleracaoX;//seta nova posicao do player
			personagens[0].posY+=personagens[0].aceleracaoY;
			personagens[1].posX+=personagens[1].aceleracaoX;//seta nova posicao do player
			personagens[1].posY+=personagens[1].aceleracaoY;
		}
		else if((teclas[C2D2_D].ativo || teclas[C2D2_DIREITA].ativo || xcon_is_key_active(xcon_dpad_right))){
			personagens[0].posX-=personagens[0].aceleracaoX;//seta nova posicao do player
			personagens[0].posY-=personagens[0].aceleracaoY;
		}
		else if((teclas[C2D2_E].ativo || teclas[C2D2_ESQUERDA].ativo || xcon_is_key_active(xcon_dpad_left))){
			personagens[0].posX+=personagens[0].aceleracaoX;//seta nova posicao do player
			personagens[0].posY+=personagens[0].aceleracaoY;
		}
	}if((personagens[0].posY+personagens[0].tamanhoY+personagens[0].aceleracaoY)>=altura_chao){ // ve se est no chao
		personagens[0].posY=altura_chao-personagens[0].tamanhoY;
		personagens[0].aceleracaoY=0;
		jogador_pula[0]=parado;
	}if((personagens[1].posY+personagens[1].tamanhoY+personagens[0].aceleracaoY)>=altura_chao){ // ve se est no chao
		personagens[1].posY=altura_chao-personagens[1].tamanhoY;
		personagens[1].aceleracaoY=0;
		jogador_pula[1]=parado;
	}
	if(playerColidePorta()){
		movimenta_fundo(0);
		movimenta_Objetos(0);
		personagens[1].aceleracaoX=0;
		personagens[0].aceleracaoX=0;
	}
	else{
		movimenta_fundo(personagens[0].aceleracaoX);
		movimenta_Objetos(personagens[0].aceleracaoX);
	}
	return situacao;
}

void jogador_processa_teclado(){//Pega tecla e move o jogador

	C2D2_Botao *teclas = C2D2_PegaTeclas();
	if(teclas[C2D2_D].ativo || teclas[C2D2_DIREITA].ativo || xcon_is_key_active(xcon_dpad_right)){
		if(jogador_animacao<jogador_move_direita_inicio || jogador_animacao>jogador_move_direita_fim){
			jogador_animacao=jogador_move_direita_inicio;
			cnt_mov=6;
		}else if(cnt_mov)cnt_mov--;
		else{
			if(jogador_animacao==jogador_move_direita_fim)
				jogador_animacao=jogador_move_direita_inicio;
			else jogador_animacao++;
			cnt_mov=6;
		}
		personagens[0].aceleracaoX = personagens[1].aceleracaoX = 16;
		int valor = personagens[0].posX - personagens[1].posX;
		if(valor>personagens[1].tamanhoX*8 +35){
				personagens[1].aceleracaoX = 13;
		}else if(valor<personagens[1].tamanhoX*8 -35){
				personagens[1].aceleracaoX = 11;
		}
	}else if(teclas[C2D2_A].ativo || teclas[C2D2_ESQUERDA].ativo || xcon_is_key_active(xcon_dpad_left)){
		if(jogador_animacao<jogador_move_esquerda_inicio || jogador_animacao>jogador_move_esquerda_fim){
			jogador_animacao=jogador_move_esquerda_inicio;
			cnt_mov=6;
		}else if(cnt_mov)cnt_mov--;
		else{
			if(jogador_animacao==jogador_move_esquerda_fim)
				jogador_animacao=jogador_move_esquerda_inicio;
			else jogador_animacao++;
			cnt_mov=6;
		}
		personagens[0].aceleracaoX = personagens[1].aceleracaoX = -16;
		int valor = personagens[1].posX - personagens[0].posX;
		if(valor<35){
			personagens[1].aceleracaoX = -11;
		}else if(valor>35){
			personagens[1].aceleracaoX = -13;
		}
	}else if(teclas[C2D2_S].ativo || teclas[C2D2_BAIXO].ativo || xcon_is_key_active(xcon_dpad_down)){
		jogador_animacao=9;
		personagens[0].aceleracaoX = personagens[1].aceleracaoX = 0;
	}else{
		jogador_animacao=0;
		personagens[0].aceleracaoX = personagens[1].aceleracaoX = 0;
	}if(teclas[C2D2_W].pressionado || teclas[C2D2_CIMA].pressionado || xcon_is_key_pressed(xcon_key_a)){
		if(personagens[0].posY+personagens[0].tamanhoY>=altura_chao){
			jogador_pula[0] = pula;
			personagens[0].posY--;
		}
	}
}

void gravidade_jogador(int jogador){
	if(personagens[0].aceleracaoY<=-10) // entrou nessa linha ele no para do nada, mas vai desacelerando at cair
		jogador_pula[0]=cai;
	if(jogador_pula[0]==pula){
		personagens[0].aceleracaoY=personagens[0].aceleracaoY-1;
	}else if(jogador_pula[0]==cai){
		personagens[0].aceleracaoY=personagens[0].aceleracaoY+1;
	}
	if(personagens[1].aceleracaoY<=-10) // entrou nessa linha ele no para do nada, mas vai desacelerando at cair
		jogador_pula[1]=cai;
	if(jogador_pula[1]==pula){
		personagens[1].aceleracaoY=personagens[1].aceleracaoY-1;
	}else if(jogador_pula[1]==cai){
		personagens[1].aceleracaoY=personagens[1].aceleracaoY+1;
	}
}